const fs = require('fs');
var QRCode = require('qrcode')
const axios = require('axios');
const { Client, Location, List, Buttons, LocalAuth } = require('./node_modules/whatsapp-web.js/index');



//SERVIDOR API
var express = require("express"),
app = express(),
bodyParser  = require("body-parser"),
methodOverride = require("method-override");

app.use(bodyParser.urlencoded({ extended: false }));
app.use(bodyParser.json());
app.use(methodOverride());
var router = express.Router();


app.use(router);

var server = app.listen(process.env.PORT || 3005);
const io = require('socket.io')(server,{
    allowEIO3: true
});
app.set('socketio', io);


//---FIN SERVIDOR API

const client = new Client({ 
    authStrategy: new LocalAuth(),
    puppeteer: { headless: true,args:['--no-sandbox','--disable-setuid-sandbox', '--disable-extensions'] },
webVersionCache: {
type: 'remote',
remotePath: 'https://raw.githubusercontent.com/wppconnect-team/wa-version/main/html/2.2410.1.html',
}
});

client.initialize();

client.on('qr', (qr) => {
    console.log("QR");
    axios.get('http://127.0.0.1/admin/ajax/winput?action=logout');
    QRCode.toDataURL(qr, function (err, url) {
        io.emit('getqr', url);
    })
    
});

client.on('authenticated', () => {
    console.log("CONECTADO")
    io.emit('closeqr','close');
    axios.get('http://127.0.0.1/admin/ajax/winput?action=login');
});

client.on('auth_failure', msg => {
    io.emit('closesion',reason);
    axios.get('http://127.0.0.1/admin/ajax/winput?action=logout');

    try{
        client.initialize();
    } catch (error) {
            
    }
});

client.on('ready',async () => {
    console.log('READY');
});

client.on('message', async msg => {
     var archivodown='';

     try{
	 	var chatorigen=await msg.getChat();
	 	chatorigen.mensaje=msg;

	    axios.post('http://127.0.0.1/admin/ajax/winput',chatorigen).then(async res => {
    			if(!res.data.existe){
    				res.data.avatar=await client.getProfilePicUrl(chatorigen.id.user);
    				io.emit('newContacto',res.data);
    			}
		
  		}).catch((error) => {
            console.log(error)
        });

          if(msg.hasMedia) {

                if (!fs.existsSync('./files/'+msg.id.id)) {

                    archivodown= await msg.downloadMedia();
                    await fs.promises.writeFile('./files/'+msg.id.id,archivodown.data, 'base64');
                    //let buff = new Buffer(archivodown.data, 'base64');
                    //fs.writeFileSync('./files/'+msg.id.id, buff);
                }
                
            }

    } catch (error) {
    
    }


   
    io.emit('newmessagewat',msg);
    
});

client.on('message_create', async (msg) => {
    try{

     var archivodown='';
    if (msg.fromMe) {
        if(msg.hasMedia) {

            if (!fs.existsSync('./files/'+msg.id.id)) {

                archivodown= await msg.downloadMedia();
                await fs.promises.writeFile('./files/'+msg.id.id,archivodown.data, 'base64');
            }
        }

        io.emit('newmessagewat',msg);

        let chats= await msg.getChat();
            chats.sendSeen();

    }

    } catch (error) {
            
    }


});


client.on('message_ack', (msg, ack) => {
    if(ack == 3) {
        io.emit('ackmessage',msg);
    }
});


client.on('disconnected', (reason) => {
    client.initialize();
    axios.get('http://127.0.0.1/admin/ajax/winput?action=logout');
    try{
        io.emit('closesion',reason);
    } catch (error) {
            
    }
});


//-->ENVIAR ARCHIVO
router.post('/sendfile',function(req, res) {
    try{
    const { MessageMedia } = require('whatsapp-web.js');
    const media = MessageMedia.fromFilePath('./files/'+req.body.file);
    //chat.sendMessage(media);
    client.sendMessage(req.body.id,media)

    io.emit('makread',{id:req.body.id,tecnico:req.body.tecnico,nametecnico:req.body.nametecnico});

    } catch (error) {
        
    }

    res.status(200).jsonp({"estado":"enviado"});
});

router.post('/sendfileauto',function(req, res) {
    try{
    const { MessageMedia } = require('whatsapp-web.js');
    const media = MessageMedia.fromFilePath(req.body.file);
    client.sendMessage(req.body.id,media)

    } catch (error) {
        
    }

    res.status(200).jsonp({"estado":"enviado"});
});




//-->ENVIAR MENSAJE
router.post('/sendmessage',async function(req, res) {
    try {
   await client.sendMessage(req.body.id, req.body.message)
   res.status(200).jsonp({"status": true});
   } catch (error) {
    await res.status(200).jsonp({"status": false,"error":error});
    }

    io.emit('makread',{id:req.body.id,tecnico:req.body.tecnico,nametecnico:req.body.nametecnico});
});


//-->MOSTRAR CHATS
router.get('/chats',async function(req, res) {
    try {
        await client.getChats().then(async(chats) => {

        res.status(200).jsonp({"chats":chats});

            
        })
    } catch (error) {
        console.log(error);
        res.status(200).jsonp({"chats":""});
    }
});


//-->CERRAR CHAT
router.post('/closechat',async function(req, res) {
    io.emit('closechat',req.body.id);
    res.status(200).jsonp({"close": "true"});
});


//-->MOSTRAR AVATAR
router.get('/avatar/:id',async function(req, res) {
    try{
    var  avatar = await client.getProfilePicUrl(req.params.id);
        res.status(200).jsonp({"avatar": avatar});
    } catch (error) {
        res.status(200).jsonp({"avatar": ""});
    }
})


//-->MOSTRAR CHAT CONTACTO
router.get('/chats/:id/:limit',async function(req, res) {

if(client){
    var isconected = await client.getState();
    if(isconected!=='CONNECTED'){
        res.status(200).jsonp({"error":"No conectado, espere unos minutos y vuelva intentarlo."});
        return;
    }
}else{
    res.status(200).jsonp({"error":"No conectado, espere unos minutos y vuelva intentarlo."});
    return;
}
    try{

        io.emit('makread',{id:req.params.id,tecnico:""});

        client.getChatById(req.params.id).then(async (chat) => {
    
        chat.fetchMessages({limit: req.params.limit}).then(async(messages) => {
        
            
        chat.sendSeen();
        var archivodown='';

            
            
                await messages.reduce(async (memo, msg,indice) => {

                    try {
                    await memo;

                    if (msg.hasQuotedMsg) {
                        messages[indice]['replica']=await msg.getQuotedMessage();
                    }

                    if(msg.hasMedia) {

                        if (!fs.existsSync('./files/'+msg.id.id)) {

                            archivodown= await msg.downloadMedia();
                            await fs.promises.writeFile('./files/'+msg.id.id,archivodown.data, 'base64');
                            //let buff = new Buffer(archivodown.data, 'base64');
                            //fs.writeFileSync('./files/'+msg.id.id, buff);
                        }
                    }

                    } catch (error) {
                        //console.log(error);
                    }
                    
                }, undefined);

                res.status(200).jsonp(messages);
        
        });

        });

    } catch (error) {
        res.status(200).jsonp({"error": "error"});
    }

});

//FIN API

//-->Info WHATSAPP
router.get('/infow',async  function(req, res) {
    if(client){
        res.status(200).jsonp({"web":await client.getWWebVersion(),"phone": await client.getState()});
    }else{
        res.status(200).jsonp({"web":"0"});
    }
    
});



//alerta sms
router.post('/conterwhatsapp',async  function(req, res) {
    io.emit('conterwhatsapp',req.body);
    res.status(200).jsonp({"enviado":"true"});
});

//alertas Admin
router.post('/notificaciones_Admin',async  function(req, res) {
    io.emit('notificaciones_Admin',req.body);
    io.emit('notificaciones_Cliente',req.body);
    res.status(200).jsonp({"enviado":"true"});
});




//RECIBE EVENTOS
io.on("connection", function(socket) {

    socket.on('logout', function() {
        client.logout();
        client.initialize();
    });

    socket.on('changeoperador', function(data) {
        io.emit('changeoperador',data);
    });

    socket.on('typing', function(data) {
        io.emit('typing',data);
    });

    socket.on("notificaciones",async (arg1,callback) => {

        try{
            const salida=await axios.get('http://127.0.0.1'+arg1);
            callback(salida.data);
        } catch (error) {
            
        }
 	});

});
